var resPath = resolvePath(".");
var timerDigits = new Array();
var timerDays = new Array();
var timerMode;
var startDate;

initializeClock();
mainWindow.visible = true;

function startCountup()
{
  preferences.watchstate.value = "Running";
  startDate = new Date();
  updateTime();
  preferences.watchstate.value = "Paused";
  updateTime();
}

function startCountdown()
{
  var result;
  
  preferences.watchstate.value = "Running";
  startDate = new Date();
  updateTime();
  preferences.watchstate.value = "Input";
}

function inputCountdown()
{
  do
  {
    result = prompt("Countdown To:", startDate, "Countdown To", "OK", "Cancel");
    if (result == null)
    {
      result = new Date();
    }
  }
  while (isNaN(Date.parse(result)));
                    
  startDate = new Date(result);
  preferences.watchstate.value = "Running";
  updateTime();    
}

function startTime()
{
  startDate = 0;
}

function pressStart()
{
  if (preferences.watchtype.value == "Countup") 
  {
    if ((preferences.watchstate.value == "Paused") || (preferences.watchstate.value == "Running"))
    {
      startDate = new Date();
      preferences.watchstate.value = "Running";
      play("Resources/beep.mp3", 1);
    }
    if (preferences.watchstate.value == "Lap")
    {
      preferences.watchstate.value = "Running";
      play("Resources/beep.mp3", 1);
    }
  }
  else if (preferences.watchtype.value == "Countdown") 
  {
    play("Resources/beep.mp3", 1);
    inputCountdown();
    play("Resources/beep.mp3", 1);
  }
}

function pressLap()
{
var currentDate = new Date();

  if (preferences.watchtype.value == "Countup")
  {
    if (preferences.watchstate.value == "Lap")
    {
      startCountup();
    }
    else
    {
      preferences.watchstate.value = "Lap";
    }
    play("Resources/beep.mp3", 1);
  }
  if ((preferences.watchtype.value == "Countdown") && (startDate < currentDate))
  {
	  preferences.watchstate.value = "Paused";
  }
}

function pressMode()
{
  if (preferences.watchtype.value == "Countup")
  {
    preferences.watchtype.value = "Countdown";
    startCountdown();
  }
  else if (preferences.watchtype.value == "Countdown")
  {
    preferences.watchtype.value = "Time";
    startTime();
  }
  else if (preferences.watchtype.value == "Time")
  {
    preferences.watchtype.value = "Countup";
    startCountup();
  }
  play("Resources/beep.mp3", 1);
}

function initializeClock()
{
   for (i = 0; i < 4; i++)
   {
      timerDigits[ i ] =  new Image();
      timerDigits[ i ].src = resPath + "/Resources/main-0.png";
      timerDigits[ i ].opacity = 255;
      timerDigits[ i ].window = mainWindow;
      timerDigits[ i ].zOrder = 1;
   }
   
   for (i = 0; i < 2; i++)
   {
      timerDigits[ 4 + i ] =  new Image();
      timerDigits[ 4 + i ].src = resPath + "/Resources/point-0.png";
      timerDigits[ 4 + i ].opacity = 255;
      timerDigits[ 4 + i ].window = mainWindow;
      timerDigits[ 4 + i ].zOrder = 1;
   }
   
   timerDigits[ 6 ] = new Image();
   timerDigits[ 6 ].src = resPath + '/Resources/colon.png';
   timerDigits[ 6 ].opacity = 255;
   timerDigits[ 6 ].window = mainWindow;
   timerDigits[ 6 ].zOrder = 1;
   
   timerDigits[ 7 ] = new Image();
   timerDigits[ 7 ].src = resPath + '/Resources/period.png';
   timerDigits[ 7 ].opacity = 255;
   timerDigits[ 7 ].window = mainWindow;
   timerDigits[ 7 ].zOrder = 1;

   for (i = 0; i < 3; i++)
   {
      timerDays[ i ] =  new Image();
      timerDays[ i ].src = resPath + "/Resources/days-0.png";
      timerDays[ i ].opacity = 0;
      timerDays[ i ].window = mainWindow;
      timerDays[ i ].zOrder = 1;
   }

   timerDays[ 3 ] =  new Image();
   timerDays[ 3 ].src = resPath + '/Resources/days-head.png';
   timerDays[ 3 ].opacity = 0;
   timerDays[ 3 ].window = mainWindow;
   timerDays[ 3 ].zOrder = 1;

   timerDays[ 4 ] =  new Image();
   timerDays[ 4 ].src = resPath + '/Resources/days-s.png';
   timerDays[ 4 ].opacity = 0;
   timerDays[ 4 ].window = mainWindow;
   timerDays[ 4 ].zOrder = 1;

   timerMode = new Image();
   timerMode.src = resPath + '/Resources/mode-T.png';
   timerMode.opacity = 255;
   timerMode.window = mainWindow;
   timerMode.zOrder = 1; 
   
   scaleWidget();
   
   preferences.watchtype.value = "Time";
   startTime();
   updateTime();
}

function scaleWidget()
{
   var scaleFactor = preferences.scaleFactor.value / 100;

   mainWindow.height = clockFace.srcHeight * scaleFactor;
   mainWindow.width = clockFace.srcWidth * scaleFactor;
   clockFace.height = clockFace.srcHeight * scaleFactor;
   clockFace.width = clockFace.srcWidth * scaleFactor;

   modeButton.height = modeButton.srcHeight * scaleFactor;
   modeButton.width = modeButton.srcWidth * scaleFactor;
   modeButton.hOffset = 6 * scaleFactor;
   modeButton.vOffset = 128 * scaleFactor;
   
   startButton.height = startButton.srcHeight * scaleFactor;
   startButton.width = startButton.srcWidth * scaleFactor;
   startButton.hOffset = 63 * scaleFactor;
   startButton.vOffset = 153 * scaleFactor;
   
   lapButton.height = lapButton.srcHeight * scaleFactor;
   lapButton.width = lapButton.srcWidth * scaleFactor;
   lapButton.hOffset = 118 * scaleFactor;
   lapButton.vOffset = 153 * scaleFactor;

   var timerOffsets = new Array(
      {hOffset:71,vOffset:103},
      {hOffset:89, vOffset:103},
      {hOffset:111, vOffset:103},
      {hOffset:129, vOffset:103},
      {hOffset:151, vOffset:108},
      {hOffset:166, vOffset:108});
   
   var dayOffsets = new Array(
      {hOffset:74, vOffset:80},
      {hOffset:86, vOffset:80},
      {hOffset:98, vOffset:80});

   for (i = 0; i < 4; i++)
   {
      timerDigits[ i ].hOffset = timerOffsets[ i ].hOffset * scaleFactor;
      timerDigits[ i ].vOffset = timerOffsets[ i ].vOffset * scaleFactor;
      timerDigits[ i ].width = timerDigits[ i ].srcWidth * scaleFactor;
      timerDigits[ i ].height = timerDigits[ i ].srcHeight * scaleFactor;
   }
   
   for (i = 0; i < 2; i++)
   {
      timerDigits[ 4 + i ].hOffset = timerOffsets[ 4 + i ].hOffset * scaleFactor;
      timerDigits[ 4 + i ].vOffset = timerOffsets[ 4 + i ].vOffset * scaleFactor;
      timerDigits[ 4 + i ].width = timerDigits[ 4 + i ].srcWidth * scaleFactor;
      timerDigits[ 4 + i ].height = timerDigits[ 4 + i ].srcHeight * scaleFactor;
   }
   
   timerDigits[ 6 ].hOffset = 104 * scaleFactor;
   timerDigits[ 6 ].vOffset = 104 * scaleFactor;
   timerDigits[ 6 ].width = timerDigits[ 6 ].srcWidth * scaleFactor;
   timerDigits[ 6 ].height = timerDigits[ 6 ].srcHeight * scaleFactor;
   
   timerDigits[ 7 ].hOffset = 143 * scaleFactor;
   timerDigits[ 7 ].vOffset = 133 * scaleFactor;
   timerDigits[ 7 ].width = timerDigits[ 7 ].srcWidth * scaleFactor;
   timerDigits[ 7 ].height = timerDigits[ 7 ].srcHeight * scaleFactor;

   for (i = 0; i < 3; i++)
   {
      timerDays[ i ].hOffset = dayOffsets[ i ].hOffset * scaleFactor;
      timerDays[ i ].vOffset = dayOffsets[ i ].vOffset * scaleFactor;
      timerDays[ i ].width = timerDays[ i ].srcWidth * scaleFactor;
      timerDays[ i ].height = timerDays[ i ].srcHeight * scaleFactor;
   }

   timerDays[ 3 ].hOffset = 120 * scaleFactor;
   timerDays[ 3 ].vOffset = 80 * scaleFactor;
   timerDays[ 3 ].width = timerDays[ 3 ].srcWidth * scaleFactor;
   timerDays[ 3 ].height = timerDays[ 3 ].srcHeight * scaleFactor;

   timerDays[ 4 ].hOffset = 157 * scaleFactor;
   timerDays[ 4 ].vOffset = 80 * scaleFactor;
   timerDays[ 4 ].width = timerDays[ 4 ].srcWidth * scaleFactor;
   timerDays[ 4 ].height = timerDays[ 4 ].srcHeight * scaleFactor;
   
   timerMode.hOffset = 170 * scaleFactor;
   timerMode.vOffset = 80 * scaleFactor;
   timerMode.width = 8 * scaleFactor;
   timerMode.height = 8 * scaleFactor;
   
   pauseIcon.hOffset = 75 * scaleFactor;
   pauseIcon.vOffset = 80 * scaleFactor;
   pauseIcon.width = pauseIcon.srcWidth * scaleFactor;
   pauseIcon.height = pauseIcon.srcHeight * scaleFactor;
   
   lapIcon.hOffset = 70 * scaleFactor;
   lapIcon.vOffset = 80 * scaleFactor;
   lapIcon.width = lapIcon.srcWidth * scaleFactor;
   lapIcon.height = lapIcon.srcHeight * scaleFactor;
}

function updateTime()
{
   var currentDate = new Date();
   var diffDate;
   var update;
   
   update = 1;
      
   if (preferences.watchtype.value == "Countup")
   {
     if ((preferences.watchstate.value == "Paused") || (preferences.watchstate.value == "Lap"))
     {
       update = 0;
     }
   }
   else if (preferences.watchtype.value == "Countdown")
   {
     if (preferences.watchstate.value == "Input")
     {
       update = 0;
     }
   }

  if (update == 1)
  {
     if (currentDate > startDate) 
     {
        diffDate = currentDate - startDate;
     }
     else
     {
        diffDate = startDate - currentDate;
     }

     if (preferences.watchtype.value == "Time")
     {
       // it should aready be in local time, but its UTC for some reason ???
       diffDate -= (currentDate.getTimezoneOffset() * 60000);
     }
     
     if ((preferences.watchtype.value == "Countdown") && (startDate < currentDate))
     {
       diffDate = 0;
       timerMode.opacity ^=  255;
	   if ((preferences.alarmSound.value != 0) && (preferences.downSound.value != "") && (preferences.watchstate.value != "Paused"))
   	   {
	     try { 
			   if (preferences.alarmRepeat.value == 1)
			   { 
			     play(preferences.downSound.value, false); 
			   }
			   else
			   { 
				 play(preferences.downSound.value, true); 
				 preferences.watchstate.value = "Paused";
			   }
		     } catch (e) {log(e);}
   	   }
     }
     
     var days = Math.floor( diffDate / (60*60*24*1000) );
     var hours = Math.floor( diffDate%(60*60*24*1000)/(60*60*1000) );
     var minutes = Math.floor( diffDate%(60*60*24*1000)%(60*60*1000)/(60*1000) );
     var seconds = Math.floor( diffDate%(60*60*24*1000)%(60*60*1000)%(60*1000)/1000 );

     if (preferences.watchtype.value == "Time")
     {
       days = 0;
     }
    
     timerDays[ 0 ].src = resPath + "/Resources/days-" + Math.floor( days / 100 ) + ".png";
     timerDays[ 0 ].opacity = (days > 99) ? 255 : 0;
     timerDays[ 1 ].src = resPath + "/Resources/days-" + Math.floor( days % 100 / 10 ) + ".png";
     timerDays[ 1 ].opacity = (days > 9) ? 255 : 0;
     timerDays[ 2 ].src = resPath + "/Resources/days-" + Math.floor( days % 100 % 10 ) + ".png";
     timerDays[ 2 ].opacity = (days > 0) ? 255 : 0;
   
     timerDays[ 3 ].opacity = (days > 0) ? 255 : 0;
     //
     // Add 'S' if not 1 day
     // 
     timerDays[ 4 ].opacity = (days > 1) ? 255 : 0;

     timerDigits[ 6 ].opacity ^= 255;

     timerDigits[ 0 ].src = resPath + "/Resources/main-" + Math.floor( hours / 10 ) + ".png";
  //   timerDigits[ 0 ].opacity = Math.floor( hours / 10 ) ? 255 : 0;
     timerDigits[ 1 ].src = resPath + "/Resources/main-" + hours % 10 + ".png";

     timerDigits[ 2 ].src = resPath + "/Resources/main-" + Math.floor( minutes / 10 ) + ".png";
     timerDigits[ 3 ].src = resPath + "/Resources/main-" + minutes % 10 + ".png";
   
     timerDigits[ 4 ].src = resPath + "/Resources/point-" + Math.floor(seconds / 10) + ".png";
     timerDigits[ 5 ].src = resPath + "/Resources/point-" + seconds % 10 + ".png";
   
     if (preferences.watchtype.value == "Time")
     {
       timerMode.src = resPath + "/Resources/mode-T.png";
     }
     else if (preferences.watchtype.value == "Countup")
     {
       timerMode.src = resPath + "/Resources/mode-up.png";
     }
     else
     {
       timerMode.src = resPath + "/Resources/mode-down.png";
     } 
   }
   
   if ((preferences.watchtype.value == "Countup") && (preferences.watchstate.value == "Lap")) 
   {
     lapIcon.opacity ^= 255;
   }
   else
   {
     lapIcon.opacity = 0;
   }
   if ((preferences.watchtype.value == "Countup") && (preferences.watchstate.value == "Paused"))
   {
     pauseIcon.opacity ^= 255;
   }
   else
   {
     pauseIcon.opacity = 0;
   }

   if (preferences.watchtype.value == "Time") 
   {
     playTick();
   }
   if ((preferences.watchtype.value == "Countup") && (preferences.watchstate.value != "Paused"))
   {
     playTick();
   }
   if ((preferences.watchtype.value == "Countdown") && (startDate > currentDate) && (preferences.watchstate.value != "Paused"))
   {
     playTick();
   }
}

function playTick()
{
   if ((preferences.secsTick.value != 0) && (preferences.secsSound.value != ""))
   {
	   try {
			play(preferences.secsSound.value, true); 
		} catch (e) {log(e);}
   }
}

